"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const crypto = require("crypto");
class ChangeMap {
    constructor() {
        this.map = {};
    }
    checkAndUpdate(path) {
        let hash = crypto.createHash("md5");
        let buffer;
        try {
            buffer = fs.readFileSync(path);
            hash.update(buffer);
        }
        catch (e) {
            console.error(e);
            return false;
        }
        let hashString = hash.digest("hex");
        if (this.map[path] === hashString && hashString) {
            return false;
        }
        this.map[path] = hashString;
        return true;
    }
}
exports.ChangeMap = ChangeMap;
//# sourceMappingURL=changeMap.js.map