import * as fs from "fs"
import * as crypto from "crypto"

export class ChangeMap {
    public readonly map: {
        [key: string]: string
    } = {}
    constructor() {
    }
    checkAndUpdate(path: string) {
        let hash = crypto.createHash("md5")
        let buffer: Buffer
        try {
            buffer = fs.readFileSync(path)
            hash.update(buffer)
        } catch (e) {
            console.error(e)
            return false
        }
        let hashString = hash.digest("hex")
        if (this.map[path] === hashString && hashString) {
            return false
        }
        this.map[path] = hashString
        return true
    }
}
