import { Task } from "./task"
export class Rule {
    type = this.option.type || "create"
    tester = this.config[0]
    command = this.config[1]
    constructor(public readonly config: [RegExp | ((path: string) => boolean), string], public readonly option: {
        type?: string
    } = {}) {
    }
    test(path: string) {
        if (this.tester && this.tester["test"]) {
            return this.tester["test"](path)
        } else if (typeof this.tester == "function") {
            return this.tester(path)
        }
        return false
    }
    taskFromPath(path: string) {
        return new Task(path, this.command)
    }
}
