"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Leaf = require("leaf-ts");
const chokidar = require("chokidar");
class Watcher {
    constructor(watchRoot, filter) {
        this.watchRoot = watchRoot;
        this.filter = filter;
        this.events = new Leaf.EventEmitter();
        this.watcher = chokidar.watch(this.watchRoot, {
            persistent: true,
            usePolling: false,
            ignoreInitial: false,
            ignored: (data) => {
                let filtered = this.filter(data);
                if (filtered) {
                    console.log("filtering", data);
                    return true;
                }
                return false;
            }
        });
        if (typeof this.watchRoot == "string") {
            this.watchRoot = [this.watchRoot];
        }
        this.watcher.on("add", path => {
            this.events.emit("change", path);
        });
        this.watcher.on("change", path => {
            this.events.emit("change", path);
        });
    }
}
exports.Watcher = Watcher;
//# sourceMappingURL=watcher.js.map