import * as Leaf from "leaf-ts"
import * as chokidar from "chokidar"

export class Watcher {
    events = new Leaf.EventEmitter<{
        change: string
    }>()
    constructor(public watchRoot: string | string[], public readonly filter: (path: string) => boolean) {
        if (typeof this.watchRoot == "string") {
            this.watchRoot = [this.watchRoot]
        }
        this.watcher.on("add", path => {
            this.events.emit("change", path)
        })
        this.watcher.on("change", path => {
            this.events.emit("change", path)
        })
    }
    watcher = chokidar.watch(this.watchRoot, {
        persistent: true,
        usePolling: false,
        ignoreInitial: false,
        ignored: (data) => {
            let filtered = this.filter(data)
            if (filtered) {
                console.log("filtering", data)
                return true
            }
            return false
        }
    })

}
